<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <base-card class="formStyling">
    <div v-if="isLoading">
      <base-spinner></base-spinner>
    </div>
    <div v-else-if="!isLoading && units.length > 0">
      <h2>Formularz zgłoszeniowy</h2>
      <add-report-form @save-data="saveData" :units="units"></add-report-form>
    </div>
  </base-card>
</template>

<script setup>
import AddReportForm from "@/components/forms/AddReportForm.vue";
import { onMounted, ref } from "vue";
import { useStore } from "vuex";
import { useRouter } from "vue-router";

const units = ref([]);
const error = ref(null);
const isLoading = ref(false);
const response = ref(null);

const store = useStore();
const router = useRouter();

function handleError() {
  error.value = null;
}

// function readBase64Image(fileObject) {
//   const reader = new FileReader();
//
//   reader.onload = (e) => {
//     response.value = e.target.result;
//   };
//   reader.readAsText(fileObject);
// }

async function saveData(data) {
  isLoading.value = true;
  try {
    // await store.dispatch("addReport", {
    //   data,
    // });
    response.value = await store.dispatch("uploadImage", {
      data,
    });

    // readBase64Image(response.value);
    // console.log(response.value);

    await router.replace("/reports");
  } catch (er) {
    error.value = er.message || "Nie udało się wysłać raportu.";
  }
  isLoading.value = false;
}

onMounted(async function () {
  units.value = store.getters.units;
});
</script>
